var currentTime, deltaTime, tickTimer = 0;
TICK_RATE = 10, TICK_STEP = 1/TICK_RATE;


//DOM loaded, program entry point
document.addEventListener("DOMContentLoaded",function() {
	//initialize systems
	if (!InitializeGraphics()) return;
	InitializeRendering();
	InitializePixels();
	
	//create factions and pixels
	for (var i = 0; i < 2; i++) {
		var fac = FACTIONS[i];
		for (var p = 0; p < 100; p++) {
			var pX = (Math.random()-0.5)*20, pY = (Math.random()-0.5)*20;
			fac.Spawn(pX+cameraX+(i?15:-15), pY+cameraY);
		}
		activeFactions.push(fac);
	}
	
	//start main loop
	currentTime = Date.now();
	MainLoop();
});


//main update and rendering loop
function MainLoop() {
	var newTime = Date.now();
	deltaTime = (newTime-currentTime)/1000;
	currentTime = newTime;

	//fixed tick rate for game logic/physics
	tickTimer = Math.min(1, tickTimer+deltaTime);
	while (tickTimer >= TICK_STEP) {
		UpdatePixels();
		tickTimer -= TICK_STEP;
	}
	
	Render();
	
	requestAnimationFrame(MainLoop);
}
