<script type="text/plain" id="SpriteVert.glsl">
//sprite vertex shader
attribute vec4 vPos;
varying vec2 uv;

uniform vec4 camera;//xy = camera position, zw = 1/(aspect*zoom)

void main() {
	uv = vPos.zw;
	gl_Position = vec4((vPos.xy-camera.xy)*camera.zw,0,1);
}
</script>


<script type="text/plain" id="Point.glsl">
//point shader
varying vec2 uv;

void main() {
	gl_FragColor = vec4(max(0.,1.-length(uv)));
}
</script>


<script type="text/plain" id="Pixel.glsl">
//pixel shader
varying vec2 uv;
uniform vec4 color;

void main() {
	vec2 p = abs(uv);
	float av = max(p.x,p.y);
	gl_FragColor = color*(av < .5 ? 1. : 0.);
}
</script>
